<?xml version="1.0" standalone="yes"?>

<!-- Index file for RISC OS documentation by RISCOS Ltd.
     Based on style sheet originally created by Justin Fletcher
     for his documentation project. -->

<!DOCTYPE doc [
<!-- <!ENTITY escaped_extsep "&lt;47&gt;"> -->
<!-- <!ENTITY extsep "/"> -->
<!-- <!ENTITY dirsep "."> -->
<!ENTITY escaped_extsep ".">
<!ENTITY extsep ".">
<!ENTITY dirsep "/">
<!ENTITY indent "&#9;">
<!ENTITY remove "remove">
<!-- <!ENTITY remove "rm"> -->
<!ENTITY throwback "--throwback">
<!-- <!ENTITY throwback ""> -->
]>

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="text" indent="no" />

<xsl:template match="/">
<xsl:text># Makefile for building all the documetation
# (this file is autogenerated)
#
</xsl:text>

<xsl:text>all: \&#10;</xsl:text>
<xsl:apply-templates select="//page" mode="targets"/>
<xsl:text>&#10;&#10;</xsl:text>
<xsl:apply-templates select="//page"/>
<xsl:text>&#10;</xsl:text>
<xsl:text>&#10;</xsl:text>
<xsl:text>validate: &#10;</xsl:text>
<xsl:apply-templates select="//page" mode="validate"/>
<xsl:text>&#10;</xsl:text>
<xsl:text>&#10;</xsl:text>
<xsl:text>clean: &#10;</xsl:text>
<xsl:apply-templates select="//page" mode="clean"/>
<xsl:text>&indent;-&remove; index-swis/xml&#10;</xsl:text>
<xsl:text>&indent;-&remove; index-swis/html&#10;</xsl:text>
<xsl:text>&indent;-&remove; index-swis-n/html&#10;</xsl:text>
<xsl:text>&indent;-&remove; index-commands/xml&#10;</xsl:text>
<xsl:text>&indent;-&remove; index-commands/html&#10;</xsl:text>
<xsl:text>&indent;-&remove; index-messages/xml&#10;</xsl:text>
<xsl:text>&indent;-&remove; index-messages/html&#10;</xsl:text>
<xsl:text>&indent;-&remove; index-messages-n/html&#10;</xsl:text>
<xsl:text>&indent;-&remove; index-upcalls/xml&#10;</xsl:text>
<xsl:text>&indent;-&remove; index-upcalls/html&#10;</xsl:text>
<xsl:text>&indent;-&remove; index-upcalls-n/html&#10;</xsl:text>
<xsl:text>&indent;-&remove; index-services/xml&#10;</xsl:text>
<xsl:text>&indent;-&remove; index-services/html&#10;</xsl:text>
<xsl:text>&indent;-&remove; index-services-n/html&#10;</xsl:text>
<xsl:text>&indent;-&remove; index-sysvars/xml&#10;</xsl:text>
<xsl:text>&indent;-&remove; index-sysvars/html&#10;</xsl:text>
<xsl:text>&indent;-&remove; index-entrys/xml&#10;</xsl:text>
<xsl:text>&indent;-&remove; index-entrys/html&#10;</xsl:text>
<xsl:text>&indent;-&remove; index-vectors/xml&#10;</xsl:text>
<xsl:text>&indent;-&remove; index-vectors/html&#10;</xsl:text>
<xsl:text>&indent;-&remove; index-vectors-n/html&#10;</xsl:text>
<xsl:text>&indent;-&remove; index-errors/xml&#10;</xsl:text>
<xsl:text>&indent;-&remove; index-errors/html&#10;</xsl:text>
<xsl:text>&indent;-&remove; index-errors-n/html&#10;</xsl:text>
<xsl:text>&indent;-&remove; index/html&#10;</xsl:text>
<xsl:text>&indent;-&remove; index-source/html&#10;</xsl:text>
</xsl:template>

<!-- This recurses up the tree, processing each section with a directory to
     create a full path as its result -->
<xsl:template match="section" mode="uri">
<xsl:if test="@dir != ''">
 <xsl:apply-templates select=".." mode="uri" />
 <xsl:value-of select="@dir" />
 <xsl:text>/</xsl:text>
</xsl:if>
</xsl:template>
<xsl:template match="*" mode="uri"/>
<!-- and the same thing but as a RISC OS name -->
<xsl:template match="section" mode="dir">
<xsl:if test="@dir != ''">
 <xsl:apply-templates select=".." mode="dir" />
 <xsl:value-of select="@dir" />
 <xsl:text>.</xsl:text>
</xsl:if>
</xsl:template>
<xsl:template match="*" mode="dir"/>


<xsl:template match="text()">
<!-- <xsl:variable name="t" select="." /> -->
<!-- <xsl:value-of select="translate($t,'&#10;',' ')" /> -->
</xsl:template>

<xsl:template match="page" mode="targets">
<xsl:if test="@href != ''">
 <xsl:text>&indent;</xsl:text>
 <xsl:apply-templates mode="dir" select=".."/>
 <xsl:value-of select="@href"/>
 <xsl:text>&lt;47&gt;html</xsl:text>
 <xsl:text> \&#10;</xsl:text>
</xsl:if>
</xsl:template>

<xsl:template match="page" mode="validate">
<xsl:if test="@href != ''">
 <xsl:text>&indent;</xsl:text>
 <xsl:text>-xmllint &throwback; --noout --valid </xsl:text>
 <xsl:apply-templates mode="uri" select=".."/>
 <xsl:value-of select="@href"/>
 <xsl:text>.xml</xsl:text>
 <xsl:text>&#10;</xsl:text>
</xsl:if>
</xsl:template>

<xsl:template match="page" mode="clean">
<xsl:if test="@href != ''">
 <xsl:text>&indent;</xsl:text>
 <xsl:text>-&remove; </xsl:text>
 <xsl:apply-templates mode="dir" select=".."/>
 <xsl:value-of select="@href"/>
 <xsl:text>/html</xsl:text>
 <xsl:text>&#10;</xsl:text>
</xsl:if>
</xsl:template>

<xsl:template match="page">
<xsl:if test="@href != ''">
 <xsl:variable name="dir">
  <xsl:apply-templates mode="dir" select=".."/>
  <xsl:value-of select="@href"/>
 </xsl:variable>
 <xsl:variable name="uri">
  <xsl:apply-templates mode="uri" select=".."/>
  <xsl:value-of select="@href"/>
 </xsl:variable>
 
 <!-- build rule -->
 <xsl:value-of select="$dir" /><xsl:text>&lt;47&gt;html</xsl:text>
 <xsl:text>: </xsl:text>
 <xsl:value-of select="$dir" /><xsl:text>&lt;47&gt;xml</xsl:text>
 <xsl:text>&#10;</xsl:text>
 
 <xsl:text>&indent;</xsl:text>
 <xsl:text>xsltproc -output </xsl:text>
 <xsl:value-of select="$uri" /><xsl:text>.html</xsl:text>
 <xsl:text> </xsl:text>
 <xsl:text>http://gerph.org/dtd/102/prm-html.xsl</xsl:text>
 <xsl:text> </xsl:text>
 <xsl:value-of select="$uri" /><xsl:text>.xml</xsl:text>
 <xsl:text>&#10;</xsl:text>
</xsl:if>
</xsl:template>


</xsl:stylesheet>
